/*

The NetUsage Project
http://netusage.mozdev.org/

Copyright (C) 2004, NetUsage Project
This extension can be freely distributed under
the terms of the Mozilla Public Licence 1.1
See the licence at http://www.mozilla.org/MPL/

---------
NetUsage ToolItem

*/


var nuc_contract_id = "@mozilla.org/netusagecom;1";
var nuc_cid = "{489e3485-7a4a-4438-9185-bf14c0c317ba}";


var nsNetUsageCom = {
	// nsINetUsageData
	get ispname() { return this.ISP.name; },
	get planname() { return this.usagedata.planname; },

	get usage() { return this.usagedata.usage; },
	get download() { return this.usagedata.download; },
	get upload() { return this.usagedata.upload; },
	get quota() { return this.usagedata.quota; },

	get usagepo() { return this.usagedata.usagepo; },
	get downloadpo() { return this.usagedata.downloadpo; },
	get uploadpo() { return this.usagedata.uploadpo; },
	get quotapo() { return this.usagedata.quotapo; },

	get downloadf() { return this.usagedata.downloadf; },
	get uploadf() { return this.usagedata.uploadf; },
	get downloadfpo() { return this.usagedata.downloadfpo; },
	get uploadfpo() { return this.usagedata.uploadfpo; },

	get lastrecorded() { return this.usagedata.lastrecorded; },

	get startdate() { return this.usagedata.startdate.getTime(); },
	get enddate() { return this.usagedata.enddate.getTime(); },

	get lastfetched() { return this.fLastFetched; },
	get lasterror() { return this.fLastError; },

	get ispactive() { return (this.ISP != null); },
	get ispusagepageauth() { return this.ISP.usagePageAuth; },
	get ispusagepageauthrealm() { return this.ISP.usagePageAuthRealm; },
	get ispusagepageauthpostdata() { return this.ISP.usagePageAuthPostData; },
	get ispusagepageurl() { return this.ISP.usagePageUrl; },

	// nsNetUsageCom objects

	observe: function (subject, topic, data) {
		switch (topic) {
			case 'timer-callback':
			case 'netusage-update':
				// update usage
				if (this.firstTime) {
					this.init2();
					this.firstTime = false;
					this.LoadPrefs();
					this.TryUpdateUsage();
				} else {
					this.LoadPrefs();
					if (data != 'pref' || this.fLastFetched == 0) this.TryUpdateUsage();
				}
				break;
			case 'xpcom-startup':
				this.Init();
				break;
		}
	},

	// initialize the object
	Init: function () {
		this.timer = Components.classes['@mozilla.org/timer;1'].createInstance(Components.interfaces.nsITimer);
		this.conntrtimer = Components.classes['@mozilla.org/timer;1'].createInstance(Components.interfaces.nsITimer);
		//this.xmlhttp = Components.classes['@mozilla.org/xmlextras/xmlhttprequest;1'].createInstance(Components.interfaces.nsIJSXMLHttpRequest).QueryInterface(Components.interfaces.nsIXMLHttpRequest);
		this.xmlhttp = Components.classes['@mozilla.org/xmlextras/xmlhttprequest;1'].createInstance(Components.interfaces.nsIXMLHttpRequest).QueryInterface(Components.interfaces.nsIXMLHttpRequest);

		this.firstTime = true;
		this.fetching = false;
		this.secondtry = false;
		this.usagedata = null;
		this.fLastFetched = 0;
		this.fLastConnSuccessful = false;
		this.fLastError = '';

		this.ISP = null;
		this.checkInterval = 0;  // a weird (different) value to trigger the InitTimer


		this.observerSvc = Components.classes["@mozilla.org/observer-service;1"].getService().QueryInterface(Components.interfaces.nsIObserverService);
		this.observerSvc.addObserver(this, 'netusage-update', false);

		// doit !!!
		//this.observerSvc.notifyObservers(this, 'netusage-reload-prefs', null);
		//this.LoadPrefs();
                       //alert('hi');
		//if (this.ISP)
		//	observerSvc.notifyObservers(this, 'netusage-update-usage', null);

		// initial updatetimer
		//try {
		/*
		var prefrltimer = Components.classes['@mozilla.org/timer;1'].createInstance(Components.interfaces.nsITimer);
		prefrltimer.init({ cmpn: Components,
			observe: function (subject, topic, data) {
				var observerSvc = this.cmpn.classes["@mozilla.org/observer-service;1"].getService().QueryInterface(this.cmpn.interfaces.nsIObserverService);
				observerSvc.notifyObservers(null, 'netusage-update', 'usage');
			} }, 3000, prefrltimer.TYPE_ONE_SHOT); */
		//} catch (e) { dump(e) };

	},
	// init 2
	init2: function () {
		var scriptinc = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].getService().QueryInterface(Components.interfaces.mozIJSSubScriptLoader);
		scriptinc.loadSubScript("chrome://netusagebtn/content/isps.js");
		scriptinc.loadSubScript("chrome://netusagebtn/content/usagelib.js");
		this.FillISPInterface = nuFillISPInterface;
	},

	// initialises timer
	InitTimer: function () {
		this.timer.cancel();
		if (this.ISP != null)
			this.timer.init(this, this.checkInterval, this.timer.TYPE_REPEATING_SLACK);
		else
			dump('timer disabled');
	},


	// this is the UI call wrapper for updating usage
	TryUpdateUsage: function () {
		var ublogin;

		if (!this.ISP) return false;

		if (this.fetching) {
			// already trying to fetch, abort the fetch
			this.conntrtimer.cancel();
			this.xmlhttp.abort();

			// user aborted
			this.fLastError = 'User aborted usage update.';
			this.observerSvc.notifyObservers(this, 'netusage-update-gui', 'abort');

			this.fetching = false;
			this.secondtry = false;

			return false;
		} else {
			// GUI
			this.fLastError = '';
			this.fLastConnSuccessful = false;
			this.observerSvc.notifyObservers(this, 'netusage-update-gui', 'start');


			if (!(ublogin = nuLoadPass('net:usage:bar')))
				return false;

			// custom auth?
			if (this.ISP.urlAuth == nuISPAuthCustom) {
				this.ISP.urlAuthCustomLogin(ublogin[1], ublogin[2]);

			} else if (this.ISP.urlAuth == nuISPAuthCookie) {
				var poststr = this.ISP.urlAuthPostData;
				poststr = poststr.replace(/{USERNAME}/, escape(ublogin[1]));
				poststr = poststr.replace(/{PASSWORD}/, escape(ublogin[2]));
				this.cookiehttp = Components.classes['@mozilla.org/xmlextras/xmlhttprequest;1'].createInstance(Components.interfaces.nsIXMLHttpRequest).QueryInterface(Components.interfaces.nsIXMLHttpRequest);

				var hh = this.cookiehttp.QueryInterface(Components.interfaces.nsIDOMEventTarget);
				hh.addEventListener('load', this.urlAuthCookieLoad, false);
				// hh.addEventListener('error', this.urlAuthCookieError, false);
				this.cookiehttp.open('POST', this.ISP.urlLogin);
				this.cookiehttp.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
				this.cookiehttp.send(poststr);

			} else if (this.ISP.urlAuth == nuISPAuthCookieGet) {
				var poststr = this.ISP.urlLogin;
				poststr = poststr.replace(/{USERNAME}/, escape(ublogin[1]));
				poststr = poststr.replace(/{PASSWORD}/, escape(ublogin[2]));
				this.cookiehttp = Components.classes['@mozilla.org/xmlextras/xmlhttprequest;1'].createInstance(Components.interfaces.nsIXMLHttpRequest).QueryInterface(Components.interfaces.nsIXMLHttpRequest);

				var hh = this.cookiehttp.QueryInterface(Components.interfaces.nsIDOMEventTarget);
				hh.addEventListener('load', this.urlAuthCookieLoad, false);
				// hh.addEventListener('error', this.urlAuthCookieError, false);
				this.cookiehttp.open('GET', poststr);
				this.cookiehttp.send(null);

			} else {

				return this.DoUpdateUsage();
			}
		}
		// multi step auth systems sign here
		return true;
	},

	urlAuthCookieLoad: function () {
		var a,r;

		var umISP = nsNetUsageCom.ISP;
		var txtdoc = this.responseText;

		// check if result contains error text
		if (('regexpErr' in umISP) && (r = umISP.regexpErr) && (a = r.exec(txtdoc))) {
			nsNetUsageCom.fLastError = (a[1]) ? 'ISP Feed Error: '+a[1] : 'Login failed. Wrong Username or Password.';
			nsNetUsageCom.observerSvc.notifyObservers(this, 'netusage-update-gui', 'error');
			nsNetUsageCom.secondtry = false;
			nsNetUsageCom.fetching = false;
			return;
		}
		
		nsNetUsageCom.DoUpdateUsage();
	},
	urlAuthCookieError: function () {
		// TODO:
	},
	urlAuthCookieLogout: function () {
		nsNetUsageCom.cookiehttp = Components.classes['@mozilla.org/xmlextras/xmlhttprequest;1'].createInstance(Components.interfaces.nsIJSXMLHttpRequest).QueryInterface(Components.interfaces.nsIXMLHttpRequest);
		nsNetUsageCom.cookiehttp.open('GET', this.ISP.urlLogout);
		nsNetUsageCom.cookiehttp.send(null);
	},

	// this gets the xmlhttp to update usage
	DoUpdateUsage: function () {
		var ublogin;

		try { // abort any running fetches
		this.xmlhttp.abort();
		} catch(e) { }

		if (!this.ISP) return false;

		// start fetching
			if (!(ublogin = nuLoadPass('net:usage:bar')))
				return false;

			this.fetching = true;

			// url subing
			var url = this.ISP.url;
			url = url.replace(/{TIMESTAMP}/, Math.round((new Date()).getTime()/1000));
			url = url.replace(/{USERNAME}/, escape(ublogin[1]));
			url = url.replace(/{PASSWORD}/, escape(ublogin[2]));

			// fetch
			//this.xmlhttp.onload = this.xmlhttpload;
			//this.xmlhttp.onerror = this.xmlhttperror;
			var hh = this.xmlhttp.QueryInterface(Components.interfaces.nsIDOMEventTarget);
			hh.addEventListener('load', this.xmlhttpload, false);
			// hh.addEventListener('error', this.xmlhttperror, false); // DOESN'T WORK! :(

			if (this.ISP.urlAuth == nuISPAuthPost) {
				var poststr = this.ISP.urlAuthPostData;
				poststr = poststr.replace(/{USERNAME}/, escape(ublogin[1]));
				poststr = poststr.replace(/{PASSWORD}/, escape(ublogin[2]));

				this.xmlhttp.open('POST', url);

				this.xmlhttp.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
				this.xmlhttp.send(poststr);
			} else {
				this.xmlhttp.open('GET', url);

				if (this.ISP.urlAuth == nuISPAuthBasic)
					this.xmlhttp.setRequestHeader('Authorization', 'Basic ' + nuEncodeBase64(ublogin[1]+':'+ublogin[2]));

				this.xmlhttp.send(null);
			}

		// Work around for the xmlhttprequest.onerror incompetence
		// This tracks the connection by polling readyState the every 3 seconds until 4 (COMPLETED)
		this.conntrtimer.init({ cmpn: Components, nsu: this,
			observe: function (subject, topic, data) {
				//this.nsu.observerSvc.notifyObservers(this, 'netusage-update-gui', 'R '+this.nsu.xmlhttp.readyState);
				if (this.nsu.xmlhttp.readyState == 4) {
					this.nsu.conntrtimer.cancel();
					if (this.nsu.fLastConnSuccessful == false) {
						this.nsu.xmlhttpconnerror();
					}
				}
			} }, 3000, this.conntrtimer.TYPE_REPEATING_SLACK);

		return true;
	},


	// xmlhttp events
	xmlhttpload: function () {
		// this == xmlhttprequest

		nsNetUsageCom.fLastConnSuccessful = true;

		if (!(nsNetUsageCom.usagedata = nsNetUsageCom.TranslateISP(this, nsNetUsageCom.ISP))) {
			// An error has occured
			/* no second tries
			if (!nsNetUsageCom.secondtry) {
				// retry
				nsNetUsageCom.secondtry = true;
				nsNetUsageCom.DoUpdateUsage();
			} else */ { 
				// return error msg
				if (this.status != 200 && this.status != 0) {
					nsNetUsageCom.fLastError = 'Unusual HTTP Error code: '+this.status+' '+this.statusText;
				} else {
					if (nsNetUsageCom.fLastError == '')
						nsNetUsageCom.fLastError = 'ISP usage source could not be parsed correctly :( Possibly wrong username/password';
				}
				//nsNetUsageCom.observerSvc.notifyObservers(this, 'netusage-update-gui', this.responseText);
				nsNetUsageCom.observerSvc.notifyObservers(this, 'netusage-update-gui', 'error');
				nsNetUsageCom.secondtry = false;
				nsNetUsageCom.fetching = false;
			}
			// custom auth logout
			if (nsNetUsageCom.ISP.urlAuth == nuISPAuthCustom) {
				nsNetUsageCom.ISP.urlAuthCustomLogout();
			}
			return;
		}

		// successfully fetched and parsed, THE END
		nsNetUsageCom.fetching = false;
		nsNetUsageCom.fLastFetched = (new Date()).getTime();

		// GUI
		nsNetUsageCom.observerSvc.notifyObservers(this, 'netusage-update-gui', 'draw');

		// custom auth logout
		if (nsNetUsageCom.ISP.urlAuth == nuISPAuthCustom) {
			nsNetUsageCom.ISP.urlAuthCustomLogout();
		} else if (nsNetUsageCom.ISP.urlAuth == nuISPAuthCookie) {
			nsNetUsageCom.urlAuthCookieLogout();
		}

	},
	xmlhttpconnerror: function () {
		dump('LoadError');

		/* if (!nsNetUsageCom.secondtry) {
			// retry
			nsNetUsageCom.secondtry = true;

			// re-invoke metre
			//nsNetUsageCom.observerSvc.notifyObservers(this, 'netusage-update', 'usage');
			nsNetUsageCom.DoUpdateUsage();

		} else */ {
			// error
			this.fLastError = 'Connection failed :(';
			this.observerSvc.notifyObservers(this, 'netusage-update-gui', 'error');
			this.fetching = false;
			this.secondtry = false;
		}
		// custom auth logout
		if (this.ISP.urlAuth == nuISPAuthCustom) {
			this.ISP.urlAuthCustomLogout();
		}
	},


	// transform ISP
	TranslateISP: function (httpobj, umISP) {

		if (!('strToInt' in umISP)) {
			umISP.strToInt = function(m, s) {
				return parseInt(s, 10);
			}
		}
		if (!('strToDate' in umISP)) {
			umISP.strToDate = function(m, s) {
				// generic 25/10/2004
				var xpdtar;
				xpdtar = s.split(/[-\/]/);
				if (m == 'start') {
					return new Date(parseInt(xpdtar[2], 10), parseInt(xpdtar[1], 10)-1, parseInt(xpdtar[0], 10), 0, 0, 0);
				} else if (m == 'end') {
					return new Date(parseInt(xpdtar[2], 10), parseInt(xpdtar[1], 10)-1, parseInt(xpdtar[0], 10), 23, 59, 59);
				} else if (m == 'roll') {
					return new Date(parseInt(xpdtar[2], 10), parseInt(xpdtar[1], 10)-1, parseInt(xpdtar[0], 10), 0, 0, 0);
				}
			}
		}

		if ('regexp1P' in umISP || 'regexp1' in umISP) {
			var txtdoc = httpobj.responseText;
			if (!txtdoc) {
				dump('no txt doc');
				return false;
			}
			return nsNetUsageCom.TranslateISPRegExp(txtdoc, umISP);
		} else {
			var xmldoc = httpobj.responseXML;
			if (!xmldoc) {
				dump('no xml doc');
				return false;
			}
			return nsNetUsageCom.TranslateISPXML(xmldoc, umISP);
		}

	},
	TranslateISPXML: function (xmldoc, umISP) {
		var nodedl, nodeul, nodeqt, nodedlp, nodeulp, nodeqtp, nodedlpo, nodeulpo, nodeqtpo;

		if (!xmldoc.evaluate(umISP.xpVerify, xmldoc, null, 9, null).singleNodeValue) {
			dump('no xml node or Incorrect version');
			var errortext = ('xpError' in umISP) ? xmldoc.evaluate(umISP.xpError, xmldoc, null, 2, null).stringValue : '';
			if (errortext != '')
				nsNetUsageCom.fLastError = 'ISP Feed Error: '+errortext;
			return null;
		}

		var aplanname = ('xpPlanName' in umISP) ? xmldoc.evaluate(umISP.xpPlanName, xmldoc, null, 2, null).stringValue : '';

		// dates
		var astartdate, aenddate, xpdtar;

		if ('xpStartDate' in umISP) {
			// ISP has irregular billing cycles
			//var xpstartdate = '01-06-2003';
			//var xpenddate = '30-06-2003';
			var xpstartdate = xmldoc.evaluate(umISP.xpStartDate, xmldoc, null, 2, null).stringValue;
			var xpenddate = xmldoc.evaluate(umISP.xpEndDate, xmldoc, null, 2, null).stringValue;

			astartdate = umISP.strToDate('start', xpstartdate);
			aenddate = umISP.strToDate('end', xpenddate);
		} else {
			// TODO: integrate with regexp
			var nowdate = new Date();
			var nowmonth = nowdate.getMonth();
			var nowyear = nowdate.getFullYear();
			// remember: illogical JS has 0 based months
			var daysInMonth = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
			// leap detection
			if (nowyear % 400 == 0 || (nowyear % 4 == 0 && nowyear % 100 != 0)) daysInMonth[1] = 29;

			var startday = (umISP.overridestartday > 1) ? umISP.overridestartday : (('xpNextRollDay' in umISP) ? xmldoc.evaluate(umISP.xpNextRollDay, xmldoc, null, 1, null).numberValue : -1);

			if (startday > 1) {
				// overridestartday

				if (nowdate.getDate() < startday) {
					// last start day in prev month
					astartdate = new Date((nowmonth-1 < 0) ? (nowyear-1) : (nowyear), (nowmonth-1 < 0) ? 12: (nowmonth-1), startday, 0, 0, 0);
					aenddate = new Date(nowyear, nowmonth, startday-1, 23, 59, 59);
				} else {
					// last start day is in this month or today
					astartdate = new Date(nowyear, nowmonth, startday, 0, 0, 0);
					aenddate = new Date((nowmonth+1 > 11) ? (nowyear+1) : (nowyear), (nowmonth+1 > 11) ? 0: (nowmonth+1), startday-1, 23, 59, 59);
				}
			} else {
				// ISP is day1 based
				astartdate = new Date(nowyear, nowmonth, 1, 0, 0, 0);
				aenddate = new Date(nowyear, nowmonth, daysInMonth[nowmonth], 23, 59, 59);
			}
		}

		// numbers
		var dl = ul = qt = used = dlf = ulf
		 = dlpo = ulpo = qtpo = usedpo = dlfpo = ulfpo = 0;

		if ((('xpDownloadPO' in umISP) && xmldoc.evaluate(umISP.xpDownloadPO, xmldoc, null, 9, null).singleNodeValue)
			|| (('xpLimitPO' in umISP) && xmldoc.evaluate(umISP.xpLimitPO, xmldoc, null, 9, null).singleNodeValue)) {
			// on peak off peak mode
			dl = umISP.strToInt('dl', xmldoc.evaluate(umISP.xpDownloadP, xmldoc, null, 1, null).numberValue);
			ul = umISP.strToInt('ul', xmldoc.evaluate(umISP.xpUploadP, xmldoc, null, 1, null).numberValue);
			qt = (umISP.overridelimit > -1) ? umISP.overridelimit : umISP.strToInt('qt', xmldoc.evaluate(umISP.xpLimitP, xmldoc, null, 1, null).numberValue);
			dlpo = umISP.strToInt('dl', xmldoc.evaluate(umISP.xpDownloadPO, xmldoc, null, 1, null).numberValue);
			ulpo = umISP.strToInt('ul', xmldoc.evaluate(umISP.xpUploadPO, xmldoc, null, 1, null).numberValue);
			qtpo = (umISP.overridelimitpo > -1) ? umISP.overridelimitpo : umISP.strToInt('qt', xmldoc.evaluate(umISP.xpLimitPO, xmldoc, null, 1, null).numberValue);

			used = dl;
			usedpo = dlpo;
		} else {
			// no off peak on peak mode
			bl = ('xpBalance' in umISP) ? umISP.strToInt('bl', xmldoc.evaluate(umISP.xpBalance, xmldoc, null, 1, null).numberValue) : 0;
			dl = ('xpDownload' in umISP) ? umISP.strToInt('dl', xmldoc.evaluate(umISP.xpDownload, xmldoc, null, 1, null).numberValue) : 0;
			ul = ('xpUpload' in umISP) ? umISP.strToInt('ul', xmldoc.evaluate(umISP.xpUpload, xmldoc, null, 1, null).numberValue) : 0;
			qt = (umISP.overridelimit > -1) ? umISP.overridelimit : umISP.strToInt('qt', xmldoc.evaluate(umISP.xpLimit, xmldoc, null, 1, null).numberValue);

			if (umISP.mode == nuISPRelax)
				// bpuddle rip off mode
				used = bl;
			else
				used = dl;
		}

		// free data
		// TODO: clean up mess
		if (('xpDownloadFPO' in umISP) && (xmldoc.evaluate(umISP.xpDownloadFPO, xmldoc, null, 9, null).singleNodeValue || xmldoc.evaluate(umISP.xpLimitPO, xmldoc, null, 9, null).singleNodeValue)) {
			dlf = ('xpDownloadFP' in umISP) ? umISP.strToInt('dl', xmldoc.evaluate(umISP.xpDownloadFP, xmldoc, null, 1, null).numberValue) : 0;
			ulf = ('xpUploadFP' in umISP) ? umISP.strToInt('ul', xmldoc.evaluate(umISP.xpUploadFP, xmldoc, null, 1, null).numberValue) : 0;
			dlfpo = ('xpDownloadFPO' in umISP) ? umISP.strToInt('dl', xmldoc.evaluate(umISP.xpDownloadFPO, xmldoc, null, 1, null).numberValue) : 0;
			ulfpo = ('xpUploadFPO' in umISP) ? umISP.strToInt('ul', xmldoc.evaluate(umISP.xpUploadFPO, xmldoc, null, 1, null).numberValue) : 0;
		} else {
			dlf = ('xpDownloadF' in umISP) ? umISP.strToInt('dl', xmldoc.evaluate(umISP.xpDownloadF, xmldoc, null, 1, null).numberValue) : 0;
			ulf = ('xpUploadF' in umISP) ? umISP.strToInt('ul', xmldoc.evaluate(umISP.xpUploadF, xmldoc, null, 1, null).numberValue) : 0;
		}

		return {
			planname: aplanname,
			usage: used,
			usagepo: usedpo,
			download: dl,
			upload: ul,
			quota: qt,
			downloadpo: dlpo,
			uploadpo: ulpo,
			quotapo: qtpo,
			downloadf: dlf,
			uploadf: ulf,
			downloadfpo: dlfpo,
			uploadfpo: ulfpo,

			startdate: astartdate,
			enddate: aenddate
		}
	},
	TranslateISPRegExp: function (txtdoc, umISP) {
		var a, r, offpeakmode;

		if ('regexp1P' in umISP) {
			// try peak/offpeak mode
			r = umISP.regexp1P;
			offpeakmode = true;
			a = r.exec(txtdoc);
		}
		if (!a && 'regexp1' in umISP) {
			// try normal mode
			r = umISP.regexp1;
			var offpeakmode = false;
			a = r.exec(txtdoc);
		}

		if (!a) {
			dump('Incorrect html version - ISP changed their page layout');
			if (('regexpErr' in umISP) && (r = umISP.regexpErr) && (a = r.exec(txtdoc)))
				nsNetUsageCom.fLastError = (a[1]) ? 'ISP Feed Error: '+a[1] : 'Login failed. Wrong Username or Password.';

			return null;
		}

		a[0] = 0;

		// PLAN NAME
		aplanname = a[umISP.iPlanName] ? a[umISP.iPlanName] : '';

		// dates
		var astartdate, aenddate;

		// START/END DATES
		if ('iStartDate' in umISP) {
			astartdate = umISP.strToDate('start', a[umISP.iStartDate]);
			aenddate = umISP.strToDate('end', a[umISP.iEndDate]);
		} else if ('iNextRollDate' in umISP) {
			aenddate = umISP.strToDate('roll', a[umISP.iNextRollDate]);
			xpdtar = [aenddate.getDate(), aenddate.getMonth()+1, aenddate.getFullYear()]; // TODO: make better!
			if (parseInt(xpdtar[1], 10) == 1) {
				xpdtar[1] = 12;
				xpdtar[2] = parseInt(xpdtar[2], 10)-1;
			} else {
				xpdtar[1] = parseInt(xpdtar[1], 10)-1;
			}
			astartdate = new Date(parseInt(xpdtar[2], 10), parseInt(xpdtar[1], 10)-1, parseInt(xpdtar[0], 10), 0, 0, 0);
		} else {
			// TODO: unify with XP func
			var nowdate = new Date();
			var nowmonth = nowdate.getMonth();
			var nowyear = nowdate.getFullYear();
			// remember: illogical JS has 0 based months
			var daysInMonth = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
			// leap detection
			if (nowyear % 400 == 0 || (nowyear % 4 == 0 && nowyear % 100 != 0)) daysInMonth[1] = 29;

			var startday = (umISP.overridestartday > 1) ? umISP.overridestartday : (('iNextRollDay' in umISP) ? a[umISP.iNextRollDay] : -1);

			if (startday > 1) {
				// overridestartday

				if (nowdate.getDate() < startday) {
					// last start day in prev month
					astartdate = new Date((nowmonth-1 < 0) ? (nowyear-1) : (nowyear), (nowmonth-1 < 0) ? 12: (nowmonth-1), startday, 0, 0, 0);
					aenddate = new Date(nowyear, nowmonth, startday-1, 23, 59, 59);
				} else {
					// last start day is in this month or today
					astartdate = new Date(nowyear, nowmonth, startday, 0, 0, 0);
					aenddate = new Date((nowmonth+1 > 11) ? (nowyear+1) : (nowyear), (nowmonth+1 > 11) ? 0: (nowmonth+1), startday-1, 23, 59, 59);
				}
			} else {
				// ISP is day1 based
				astartdate = new Date(nowyear, nowmonth, 1, 0, 0, 0);
				aenddate = new Date(nowyear, nowmonth, daysInMonth[nowmonth], 23, 59, 59);
			}
		}

		// numbers
		var dl = ul = qt = used = dlf = ulf
		 = dlpo = ulpo = qtpo = usedpo = dlfpo = ulfpo = 0;

		// crunch numbers
		if (offpeakmode) {
			// ONPEAK/OFFPEAK usage
			dl = umISP.strToInt('dl', a[umISP.iDownloadP]);
			ul = umISP.strToInt('ul', a[umISP.iUploadP]);
			qt = (umISP.overridelimit > -1)  ? umISP.overridelimit : umISP.strToInt('qt', a[umISP.iLimitP]);
			dlpo = umISP.strToInt('dl', a[umISP.iDownloadPO]);
			ulpo = umISP.strToInt('ul', a[umISP.iUploadPO]);
			qtpo = (umISP.overridelimitpo > -1)  ? umISP.overridelimitpo : umISP.strToInt('qt', a[umISP.iLimitPO]);

			used = dl;
			usedpo = dlpo;
		} else {
			dl = umISP.strToInt('dl', a[umISP.iDownload]);
			ul = umISP.strToInt('ul', a[umISP.iUpload]);
			qt = (umISP.overridelimit > -1)  ? umISP.overridelimit : umISP.strToInt('qt', a[umISP.iLimit]);

			if (umISP.mode == nuISPRelax)
				// bpuddle rip off mode
				used = dl + ul;
			else
				used = dl;
		}

		// free data
		dlf = ('iDownloadF' in umISP) ? umISP.strToInt('dl', a[umISP.iDownloadF]) : 0;
		ulf = ('iUploadF' in umISP) ? umISP.strToInt('ul', a[umISP.iUploadF]) : 0;


		// done
		return {
			planname: aplanname,
			usage: used,
			usagepo: usedpo,
			download: dl,
			upload: ul,
			quota: qt,
			downloadpo: dlpo,
			uploadpo: ulpo,
			quotapo: qtpo,
			downloadf: dlf,
			uploadf: ulf,
			downloadfpo: dlfpo,
			uploadfpo: ulfpo,

			startdate: astartdate,
			enddate: aenddate
		}
	},


	// load user preferences
	LoadPrefs: function () {
		var prefObj, pref, prefISP, prefCheckInterval, limit = -1, limitpo = -1, startday = -1;
		var doinittime = false;

		try {
			prefObj = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
			pref = prefObj.getBranch("extensions.netusage.");
			prefISP = pref.getCharPref("userisp");
			if (prefISP && prefISP != '' && prefISP != 'na') {

				if (this.ISP == null || this.ISP.id != prefISP)
					this.ISP = this.FillISPInterface(prefISP);

				// override default usage limits
				try {
					limit = pref.getIntPref("override_limit");
				} catch(e) {}
				this.ISP.overridelimit = limit;
				try {
					limitpo = pref.getIntPref("override_limitpo");
				} catch(e) {}
				this.ISP.overridelimitpo = limitpo;
				try {
					startday = pref.getIntPref("override_startday");
				} catch(e) {}
				this.ISP.overridestartday = startday;

			} else {
				if (this.ISP != null) {
					this.ISP = null;
					doinittime = true; // disable the timer
				}
			}
			prefCheckInterval = pref.getIntPref("checkinterval");
			// only change checkinterval if different and if interval 
			// is greater than 10 mins (minimum req, so ISP servers aren't DOS'd)
			if (this.checkInterval != prefCheckInterval * 1000) {
				if (prefCheckInterval >= 600)
					this.checkInterval = prefCheckInterval * 1000;
				else
					this.checkInterval = 3600000;
				doinittime = true; // refresh timer interval
			}
			if (doinittime)
				this.InitTimer();

		} catch(e) { dump(e); }


	},


	QueryInterface: function (iid) {
		if (!iid.equals(Components.interfaces.nsINetUsageData) &&
			!iid.equals(Components.interfaces.nsISupports) &&
			!iid.equals(Components.interfaces.nsIObserver)) {
			throw Components.results.NS_ERROR_NO_INTERFACE;
		}
		return this;
	},

}




// This Component's module implementation.  All the code below is used to get this
// component registered and accessible via XPCOM.
var module = {
	firstTime: true,

	/* CID for this class */
	cid: Components.ID(nuc_cid),

	/* Contract ID for this class */
	contractId: nuc_contract_id,

	// registerSelf: Register this component.
	registerSelf: function (compMgr, fileSpec, location, type) {
		if (this.firstTime) {
			this.firstTime = false;
			throw Components.results.NS_ERROR_FACTORY_REGISTER_AGAIN;
		}
		compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
		//compMgr.registerComponentWithType( this.cid, "NetUsage Component", this.contractId, fileSpec, location, true, true, type);
		compMgr.registerFactoryLocation(this.cid, "NetUsage Component", this.contractId, fileSpec, location, type);

		var catman = Components.classes["@mozilla.org/categorymanager;1"].getService().QueryInterface(Components.interfaces.nsICategoryManager);
		catman.addCategoryEntry("xpcom-startup", "NetUsage", nuc_contract_id, true, true);
	},

	// getClassObject: Return this component's factory object.
	getClassObject: function (compMgr, cid, iid) {
		if (!cid.equals(this.cid)) {
			throw Components.results.NS_ERROR_NO_INTERFACE;
		}

		if (!iid.equals(Components.interfaces.nsIFactory)) {
			throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
		}

		return this.factory;
	},

	/* factory object */
	factory: {
		createInstance: function (outer, iid) {
		if (outer != null)
			throw Components.results.NS_ERROR_NO_AGGREGATION;

			// a service
			return nsNetUsageCom.QueryInterface(iid);
		}
	},

	// canUnload: n/a (returns true)
	canUnload: function(compMgr) {
		return true;
	}
};

// NSGetModule: Return the nsIModule object.
function NSGetModule(compMgr, fileSpec) {
	return module;
}